# Bases de la programmation objet en C++
Ce TP supplémentaire vous permetrra d'avoir quelque bases en C++.

## Exercice 1 : Les Rectangles
Ce premier exercice vous permettra de comprendre les strcutures des fichiers utilisés en C++.
Les fichiers pour l'exercice sont disponibles dans le dossier "Rectangle"

- Le fichier "Rectangle.h" contient les déclarations
- Le fichier "Rectangle.cpp" contient les implémentations de méthodes déclarées dans le ".h"
- Le fichier "main.cpp" fait appel aux méthodes implémenter et instancies des objets.
- Le fichier Makefile permet de compiler en appelant la commande "make".

**Consigne**
Commencer par comprendre le code et les stuctures sous jacentes, puis :

1) Implémenter la méthode setWidth() dans "Rectangle.cpp"
2) Implémenter la méthode calculatePerimeter() dans "Rectangle.cpp"
3) Dans main.cpp, utiliser les méthodes "setLength" et "setWidth" pour changer les paramètres du rectangle, puis vérifier que les paramètres ont effectivement changé en affichant les nouvelles caractéristiques du rectangle.


## Exercice 2 : Les Cercles

**Consigne**

Maintenant que vous avez compris les stuctures de bases du C++, faites de même que ci-dessus, mais avec les Cercles.
De même, vous créerez 3 fichiers et un Makefile. Le fichier main.cpp doit également afficher les paramètres du cercle dans un premier temps (rayon, diamètre, aire, périmètre). De même, il est demandé de modifier le rayon dans le main.cpp et de vérifier que l'aire, le périmètre et le diamètre ont bien changés en conséquences


## Exercice 3 : TODO

Exercice un peu plus complexe pour finir

**Consigne**

1. **Création de la classe `CompteBancaire`**
   - Créez une classe `CompteBancaire` avec les attributs suivants :
     - `titulaire` (de type `std::string`)
     - `solde` (de type `double`)
   - Ajoutez un constructeur qui initialise ces attributs.
   - Ajoutez des méthodes pour :
     - Déposer de l'argent (`deposer`)
     - Retirer de l'argent (`retirer`)
     - Afficher les informations du compte (`afficher`)

2. **Implémentation des méthodes**
   - Implémentez les méthodes `deposer`, `retirer` et `afficher` dans un fichier séparé.
   - Assurez-vous que le solde ne peut pas être négatif après un retrait.

3. **Programme principal**
   - Créez un programme principal (`main.cpp`) qui :
     - Crée un objet `CompteBancaire`
     - Effectue quelques opérations de dépôt et de retrait
     - Affiche les informations du compte après chaque opération

4. **Makefile**
   - Créez un Makefile pour compiler votre programme.

## Fichiers à rendre

- `CompteBancaire.h` : Déclaration de la classe `CompteBancaire`
- `CompteBancaire.cpp` : Implémentation des méthodes de la classe `CompteBancaire`
- `main.cpp` : Programme principal
- `Makefile` : Fichier Makefile pour compiler le programme
